# -*- Mode: Python; tab-width: 4 -*-
#
# And older version that built a single exe file,
# it is out of sync right now, needs work.

# "Freeze" a Python script into a binary.

# Import standard modules

import cmp
import getopt
import os
import string
import sys

# Import the freeze-private modules

import findmodules
import makefreeze

# Main program

def main ():
	frozen_c = 'frozen.c'
	config_c = 'config_nt.c'
	makefile = 'Makefile'

	extensions = []
	scriptfile = sys.argv[1]
	modules = sys.argv[2:]

	# derive target name from script name
	base = os.path.basename(scriptfile)
	base, ext = os.path.splitext(base)
	if base:
		if base != scriptfile:
			target = base
		else:
			target = base + '.bin'

	# Actual work starts here...

	dict = findmodules.findmodules(scriptfile, modules, sys.path)
	names = dict.keys()
	names.sort()

	if 'os' in names:
		# nother special-case hack
		dict['ntpath'] = findmodules.findmodule ('ntpath', sys.path)
		names.append ('ntpath')

	print "Modules being frozen:"
	for name in names:
	    print '\t', name

	backup = frozen_c + '~'
	try:
		os.rename(frozen_c, backup)
	except os.error:
		backup = None
	outfp = open(frozen_c, 'w')
	try:
		makefreeze.makefreeze(outfp, dict)
	finally:
		outfp.close()
	if backup:
		if cmp.cmp(backup, frozen_c):
			sys.stderr.write('%s not changed, not written\n' %
					 frozen_c)
			os.rename(backup, frozen_c)

	builtins = []
	unknown = []
	mods = dict.keys()
	mods.sort()
	for mod in mods:
		if dict[mod] == '<builtin>':
			builtins.append(mod)
		elif dict[mod] == '<unknown>':
			unknown.append(mod)

	addfiles = []

	pyd_modules = match_pyd (unknown)
	print 'found these pyd modules: ', pyd_modules

	for pyd in pyd_modules:
		unknown.remove (pyd)

	if 'posix' in unknown:
		unknown.remove ('posix')

	if unknown:
		sys.stderr.write('Warning: unknown modules remain: %s\n' %
				 string.join(unknown))

	builtins.sort()

	for x in ['sys', 'imp', 'marshal', 'nt']:
		if x in builtins:
			builtins.remove (x)

	args = string.join (sys.argv)

	open (config_c, 'w').write (make_config_c_template (builtins, pyd_modules))
	open (makefile, 'w').write (make_makefile_template (args, target, builtins, pyd_modules))
	open ('frozenmain.c', 'w').write (frozenmain_c)

def find_pyd ():
	pyd_files = {}
	for path in sys.path:
		if os.path.isdir (path):
			for file in os.listdir (path):
				name = string.lower (file)
				if name[-4:] == '.pyd':
					pyd_files[name] = 1
	return pyd_files

def match_pyd (modules):
	pyd_files = find_pyd()
	result = []
	for mod in modules:
		if pyd_files.has_key (string.lower(mod) + '.pyd'):
			result.append (mod)
	return result

# three classes of modules:
# 1) builtin to the interpreter [imp, marshal, sys]
#    static: no extra objs, no extra inits [inits are hard-wired into the template]
#    dynamic: same.
# 2) builtin to py-xxx.dll [strop, md5, etc...]
#    static: must link to Modules/xxxmodule.obj, must add init line in the "C" section
#    dynamic: no link, but must add init line in the "C" section
# 3) dynamic modules [win32api, etc..]
#    static: link objects vary, must add init line in the C++ [mangled] section
#    dynamic: probably link to XXX.lib, and add C++ init line.

# Todo: add ability to pass in extra link options, for stuff like '.res' files

config_c_template = \
"""
#include "Python.h"

// references to initXXX here will be c++ mangled [which is what we want]
%s

extern "C" {

extern void PyMarshal_Init();
extern void initimp();
extern void initnt();

%s

struct {
	char *name;
	void (*initfunc)();
} inittab[] = {

    // builtins inserted here:
%s

	{"imp", initimp},
	{"marshal", PyMarshal_Init},
	{"nt",	initnt},

	/* These entries are here for sys.builtin_module_names */
	{"__main__", NULL},
	{"__builtin__", NULL},
	{"sys", NULL},

	/* Sentinel */
	{0, 0}
};

}

"""

def make_config_c_template (builtins, pyd_externals):
	externs = ''
	inittabs = ''
	pyd_externs = ''

	for e in pyd_externals:
		pyd_externs = pyd_externs + 'extern void init%s (void);\n' % (e,)
	for b in builtins:
		externs = externs + 'extern void init%s (void);\n' % (b,)
	print builtins, pyd_externals
	for m in builtins + pyd_externals:
		inittabs = inittabs + '\t{"%s", init%s},\n' % (m, m)

	return config_c_template % (pyd_externs, externs, inittabs)

makefile_template = \
"""!include <%s/make_nt.in>

# Automatically generated by freeze_win32 with the following command line:
# %s

appname = %s
pythondir = %s

BUILTIN_MODULES= %s
PYTHON_LIBS= %s

all:	%s.exe

config_nt.obj:	$*.c
	$(CC) $(cdl) -I$(pythondir)/Include -DUSE_FROZEN $(cflags) $(cdebug) $(cinclude) $(pythonopts) /Tp $*.c

$(appname).exe : frozen.obj config_nt.obj $(BUILTIN_MODULES)
	link -out:$*.exe $(pythondir)/Python/frozenmain.obj frozen.obj config_nt.obj $(BUILTIN_MODULES) $(PYTHON_LIBS) $(lcustom) $(guilibsdll) shell32.lib comdlg32.lib wsock32.lib

"""

def make_makefile_template (args, target, builtins, externals):
	bo = []

	objects = map (lambda x: '%smodule.obj' % x, builtins)
	objects = objects + ['dl_nt.obj', 'getpath_nt.obj', 'main_nt.obj', 'posixmodule.obj']
	objects = map (lambda x: '%s/Modules/%s' % (PYTHON_SRC, x), objects)

	pl = []
	for p in ['Python/Pythonc.lib', 'Parser/Parser.lib', 'Objects/Objects.lib']:
		pl.append ('%s/%s' % (PYTHON_SRC, p))
	python_libs = string.join (pl)

	for ext in externals + builtins:
		if extra_objects.has_key (ext):
			objects.append (extra_objects[ext])

	objects = string.joinfields (objects, ' \\\n\t')

	return makefile_template % (
		PYTHON_SRC, # make_nt.in line
		args,		# command line
		objects,	# object files
		python_libs,
		target,		# all: target
		PYTHON_SRC,	# -I
		target,		# exe name
		PYTHON_SRC,	# path to frozenmain
		target,		# .d.exe name
		PYTHON_SRC	# path to python.lib
		)
	
extra_objects = {
	'win32api':	['$(pythondir)/Python-Ext/win32api/win32apimodule.obj'],
	'win32ui':	['$(pythondir)/Python-Ext/pythonwi/WinRel/win32ui.lib',
				' $(pythondir)/Python-Ext/pythonwi/hierlist/WinRel/hierlib32.lib'],
	'calldll':	['$(pythondir)/Python-Ext/calldll/calldllmodule.obj'],
	'md5':		['$(pythondir)/Modules/md5c.obj'],
	'regex':	['$(pythondir)/Modules/regexpr.obj'],
	'_socket':	['$(pythondir)/Python-Ext/_socket/_socketmodule.obj'],
	'bsddb':	['$(pythondir)/Python-Ext/bsddb/bsddbmodule.obj',
				 'e:/src/db.1.85/PORT/win32/db.lib'],
	'timer':	['$(pythondir)/Python-Ext/timer/timermodule.obj'],
	}

frozenmain_c = """

#include "frozen.c"

int
main (int argc, char * argv[])
{
  int n, sts;
  Py_Initialize();
  PySys_SetArgv (argc, argv);
  
  n = PyImport_ImportFrozenModule ("__main__");
  if (n == 0) {
    Py_FatalError ("__main__ not frozen");
  } else if (n < 0) {
    PyErr_Print();
    sts = 1;
  } else {
    sts = 0;
  }
  Py_Exit (sts);
}

#include <windows.h>
int APIENTRY
WinMain (HINSTANCE hInstance,
	 HINSTANCE hPrevInstance,
	 LPSTR lpCmdLine,
	 int nCmdShow)
{
  return main(1,&lpCmdLine);
}  

"""

if __name__ == '__main__':
	main()

# we ought to build several targets:
# 
# 1) no DLL dependency.
# 2) pyXXX.dll only
#    link to python.lib, rather than to all the various object files?
# 3) pyXXX.dll + all .pyd files.
#    link to python.lib, win32api.lib, etc...

# TODO finishing fixing with make variables! $(pythondir)
